LocalVariablesSorter (ASM 5.0.4 Documentation)
Date: 2015-09-18

org.objectweb.asm.commons

## Class LocalVariablesSorter

- java.lang.Object
- - org.objectweb.asm.MethodVisitor
  - - org.objectweb.asm.commons.LocalVariablesSorter

- Direct Known Subclasses:
    GeneratorAdapter, RemappingMethodAdapter

      public class LocalVariablesSorter
      extends MethodVisitor

  A `MethodVisitor` that renumbers local variables in their order of appearance. This adapter allows one to easily add new local variables to a method. It may be used by inheriting from this class, but the preferred way of using it is via delegation: the next visitor in the chain can indeed add new locals when needed by calling `newLocal(org.objectweb.asm.Type)` on this adapter (this requires a reference back to this `LocalVariablesSorter`).
  Author:
    Chris Nokleberg, Eugene Kuleshov, Eric Bruneton

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `firstLocal` Index of the first local variable, after formal parameters.
    `protected int` | `nextLocal` Index of the next local variable to be created by `newLocal(org.objectweb.asm.Type)`.

    - ### Fields inherited from class org.objectweb.asm.MethodVisitor

      `api, mv`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `LocalVariablesSorter(int api, int access, String desc, MethodVisitor mv)` Creates a new `LocalVariablesSorter`.
    `` | `LocalVariablesSorter(int access, String desc, MethodVisitor mv)` Creates a new `LocalVariablesSorter`.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `newLocal(Type type)` Creates a new local variable of the given type.
    `protected int` | `newLocalMapping(Type type)`
    `protected void` | `setLocalType(int local, Type type)` Notifies subclasses that a local variable has been added or remapped.
    `protected void` | `updateNewLocals(Object[] newLocals)` Notifies subclasses that a new stack map frame is being visited.
    `void` | `visitFrame(int type, int nLocal, Object[] local, int nStack, Object[] stack)` Visits the current state of the local variables and operand stack elements.
    `void` | `visitIincInsn(int var, int increment)` Visits an IINC instruction.
    `void` | `visitLocalVariable(String name, String desc, String signature, Label start, Label end, int index)` Visits a local variable declaration.
    `AnnotationVisitor` | `visitLocalVariableAnnotation(int typeRef, TypePath typePath, Label[] start, Label[] end, int[] index, String desc, boolean visible)` Visits an annotation on a local variable type.
    `void` | `visitMaxs(int maxStack, int maxLocals)` Visits the maximum stack size and the maximum number of local variables of the method.
    `void` | `visitVarInsn(int opcode, int var)` Visits a local variable instruction.

    - ### Methods inherited from class org.objectweb.asm.MethodVisitor

      `visitAnnotation, visitAnnotationDefault, visitAttribute, visitCode, visitEnd, visitFieldInsn, visitInsn, visitInsnAnnotation, visitIntInsn, visitInvokeDynamicInsn, visitJumpInsn, visitLabel, visitLdcInsn, visitLineNumber, visitLookupSwitchInsn, visitMethodInsn, visitMethodInsn, visitMultiANewArrayInsn, visitParameter, visitParameterAnnotation, visitTableSwitchInsn, visitTryCatchAnnotation, visitTryCatchBlock, visitTypeAnnotation, visitTypeInsn`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### firstLocal

          protected final int firstLocal

      Index of the first local variable, after formal parameters.

    - #### nextLocal

          protected int nextLocal

      Index of the next local variable to be created by `newLocal(org.objectweb.asm.Type)`.

  - ### Constructor Detail

    - #### LocalVariablesSorter

          public LocalVariablesSorter(int access,
                              String desc,
                              MethodVisitor mv)

      Creates a new `LocalVariablesSorter`. Subclasses must not use this constructor. Instead, they must use the `LocalVariablesSorter(int, int, String, MethodVisitor)` version.
      Parameters:
        `access` - access flags of the adapted method.
        `desc` - the method's descriptor (see `Type`).
        `mv` - the method visitor to which this adapter delegates calls.
      Throws:
        `IllegalStateException` - If a subclass calls this constructor.

    - #### LocalVariablesSorter

          protected LocalVariablesSorter(int api,
                              int access,
                              String desc,
                              MethodVisitor mv)

      Creates a new `LocalVariablesSorter`.
      Parameters:
        `api` - the ASM API version implemented by this visitor. Must be one of `Opcodes.ASM4` or `Opcodes.ASM5`.
        `access` - access flags of the adapted method.
        `desc` - the method's descriptor (see `Type`).
        `mv` - the method visitor to which this adapter delegates calls.

  - ### Method Detail

    - #### visitVarInsn

          public void visitVarInsn(int opcode,
                          int var)

      Description copied from class: `MethodVisitor`
      Visits a local variable instruction. A local variable instruction is an instruction that loads or stores the value of a local variable.
      Overrides:
        `visitVarInsn` in class `MethodVisitor`
      Parameters:
        `opcode` - the opcode of the local variable instruction to be visited. This opcode is either ILOAD, LLOAD, FLOAD, DLOAD, ALOAD, ISTORE, LSTORE, FSTORE, DSTORE, ASTORE or RET.
        `var` - the operand of the instruction to be visited. This operand is the index of a local variable.

    - #### visitIincInsn

          public void visitIincInsn(int var,
                           int increment)

      Description copied from class: `MethodVisitor`
      Visits an IINC instruction.
      Overrides:
        `visitIincInsn` in class `MethodVisitor`
      Parameters:
        `var` - index of the local variable to be incremented.
        `increment` - amount to increment the local variable by.

    - #### visitMaxs

          public void visitMaxs(int maxStack,
                       int maxLocals)

      Description copied from class: `MethodVisitor`
      Visits the maximum stack size and the maximum number of local variables of the method.
      Overrides:
        `visitMaxs` in class `MethodVisitor`
      Parameters:
        `maxStack` - maximum stack size of the method.
        `maxLocals` - maximum number of local variables for the method.

    - #### visitLocalVariable

          public void visitLocalVariable(String name,
                                String desc,
                                String signature,
                                Label start,
                                Label end,
                                int index)

      Description copied from class: `MethodVisitor`
      Visits a local variable declaration.
      Overrides:
        `visitLocalVariable` in class `MethodVisitor`
      Parameters:
        `name` - the name of a local variable.
        `desc` - the type descriptor of this local variable.
        `signature` - the type signature of this local variable. May be `null` if the local variable type does not use generic types.
        `start` - the first instruction corresponding to the scope of this local variable (inclusive).
        `end` - the last instruction corresponding to the scope of this local variable (exclusive).
        `index` - the local variable's index.

    - #### visitLocalVariableAnnotation

          public AnnotationVisitor visitLocalVariableAnnotation(int typeRef,
                                                       TypePath typePath,
                                                       Label[] start,
                                                       Label[] end,
                                                       int[] index,
                                                       String desc,
                                                       boolean visible)

      Description copied from class: `MethodVisitor`
      Visits an annotation on a local variable type.
      Overrides:
        `visitLocalVariableAnnotation` in class `MethodVisitor`
      Parameters:
        `typeRef` - a reference to the annotated type. The sort of this type reference must be `LOCAL_VARIABLE` or `RESOURCE_VARIABLE`. See `TypeReference`.
        `typePath` - the path to the annotated type argument, wildcard bound, array element type, or static inner type within 'typeRef'. May be `null` if the annotation targets 'typeRef' as a whole.
        `start` - the fist instructions corresponding to the continuous ranges that make the scope of this local variable (inclusive).
        `end` - the last instructions corresponding to the continuous ranges that make the scope of this local variable (exclusive). This array must have the same size as the 'start' array.
        `index` - the local variable's index in each range. This array must have the same size as the 'start' array.
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### visitFrame

          public void visitFrame(int type,
                        int nLocal,
                        Object[] local,
                        int nStack,
                        Object[] stack)

      Description copied from class: `MethodVisitor`
      Visits the current state of the local variables and operand stack elements. This method must(*) be called just before any instruction i that follows an unconditional branch instruction such as GOTO or THROW, that is the target of a jump instruction, or that starts an exception handler block. The visited types must describe the values of the local variables and of the operand stack elements just before i is executed.
      (*) this is mandatory only for classes whose version is greater than or equal to `V1_6`.
      The frames of a method must be given either in expanded form, or in compressed form (all frames must use the same format, i.e. you must not mix expanded and compressed frames within a single method):
      - In expanded form, all frames must have the F_NEW type.
      - In compressed form, frames are basically "deltas" from the state of the previous frame:
        - `Opcodes.F_SAME` representing frame with exactly the same locals as the previous frame and with the empty stack.
        - `Opcodes.F_SAME1` representing frame with exactly the same locals as the previous frame and with single value on the stack ( `nStack` is 1 and `stack[0]` contains value for the type of the stack item).
        - `Opcodes.F_APPEND` representing frame with current locals are the same as the locals in the previous frame, except that additional locals are defined (`nLocal` is 1, 2 or 3 and `local` elements contains values representing added types).
        - `Opcodes.F_CHOP` representing frame with current locals are the same as the locals in the previous frame, except that the last 1-3 locals are absent and with the empty stack (`nLocals` is 1, 2 or 3).
        - `Opcodes.F_FULL` representing complete frame data.
      In both cases the first frame, corresponding to the method's parameters and access flags, is implicit and must not be visited. Also, it is illegal to visit two or more frames for the same code location (i.e., at least one instruction must be visited between two calls to visitFrame).
      Overrides:
        `visitFrame` in class `MethodVisitor`
      Parameters:
        `type` - the type of this stack map frame. Must be `Opcodes.F_NEW` for expanded frames, or `Opcodes.F_FULL`, `Opcodes.F_APPEND`, `Opcodes.F_CHOP`, `Opcodes.F_SAME` or `Opcodes.F_APPEND`, `Opcodes.F_SAME1` for compressed frames.
        `nLocal` - the number of local variables in the visited frame.
        `local` - the local variable types in this frame. This array must not be modified. Primitive types are represented by `Opcodes.TOP`, `Opcodes.INTEGER`, `Opcodes.FLOAT`, `Opcodes.LONG`, `Opcodes.DOUBLE`,`Opcodes.NULL` or `Opcodes.UNINITIALIZED_THIS` (long and double are represented by a single element). Reference types are represented by String objects (representing internal names), and uninitialized types by Label objects (this label designates the NEW instruction that created this uninitialized value).
        `nStack` - the number of operand stack elements in the visited frame.
        `stack` - the operand stack types in this frame. This array must not be modified. Its content has the same format as the "local" array.

    - #### newLocal

          public int newLocal(Type type)

      Creates a new local variable of the given type.
      Parameters:
        `type` - the type of the local variable to be created.
      Returns:
        the identifier of the newly created local variable.

    - #### updateNewLocals

          protected void updateNewLocals(Object[] newLocals)

      Notifies subclasses that a new stack map frame is being visited. The array argument contains the stack map frame types corresponding to the local variables added with `newLocal(org.objectweb.asm.Type)`. This method can update these types in place for the stack map frame being visited. The default implementation of this method does nothing, i.e. a local variable added with `newLocal(org.objectweb.asm.Type)` will have the same type in all stack map frames. But this behavior is not always the desired one, for instance if a local variable is added in the middle of a try/catch block: the frame for the exception handler should have a TOP type for this new local.
      Parameters:
        `newLocals` - the stack map frame types corresponding to the local variables added with `newLocal(org.objectweb.asm.Type)` (and null for the others). The format of this array is the same as in `MethodVisitor.visitFrame(int, int, java.lang.Object[], int, java.lang.Object[])`, except that long and double types use two slots. The types for the current stack map frame must be updated in place in this array.

    - #### setLocalType

          protected void setLocalType(int local,
                          Type type)

      Notifies subclasses that a local variable has been added or remapped. The default implementation of this method does nothing.
      Parameters:
        `local` - a local variable identifier, as returned by `newLocal()`.
        `type` - the type of the value being stored in the local variable.

    - #### newLocalMapping

          protected int newLocalMapping(Type type)